/* Copyright (c) 2006-2018 Peter Speck / Vitality. All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Vitality nor the names of its contributors may be
 *       used to endorse or promote products derived from this software without
 *       specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY PETER SPECK / VITALITY AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL PETER SPECK / VITALITY AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR  SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.jabhts.junit.tests.lScope;

import org.jabhts.annotation.element.EHtml;
import org.jabhts.annotation.element.EText;
import org.jabhts.annotation.element.ETextPre;
import org.jabhts.annotation.flowControl.EScopeChilds;
import org.jabhts.annotation.global.TCompile;
import org.jabhts.junit.lib.TestBase;

@TCompile
public class TestScope extends TestBase
{
	@EText
	String getTextOne()
	{
		return "Making a test";
	}

	@EScopeChilds
	class BlockOne
	{
		@EText
		String getString1()
		{
			return "scope-1-get";
		}

		@EHtml
		void printString2()
		{
			pw.htmlEncode("scope-1-print");
		}
	}

	@EScopeChilds
	static class BlockTwo
	{
		@EText
		String getString1()
		{
			return "scope-2-get";
		}
	}

	/*
	Support for double-processing of element for scopes disabled due to complex warning handling
	@EScope(tag = "title")
	class Title
	{
		@EContent(tag = "title")
		void printTitle()
		{
			pw.print("Testing gone amuck");
		}
	}
	*/

	@EText(tag = "strong")
	String strong = "Testing gone amuck";

	@ETextPre("StrongContainer")
	String empty = "";

	protected void emitTemplate() throws Exception
	{
		new TestScopeTp(this).emit(pw);
	}
}
